=== debian/changelog ===
openmodelica (22929-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Sat, 25 Oct 2014 07:22:13 +0200
